/* Intel Atom/32 gmp-mparam.h -- Compiler/machine parameter header file.

Copyright 1991, 1993, 1994, 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007,
2008, 2009, 2010 Free Software Foundation, Inc.

This file is part of the GNU MP Library.

The GNU MP Library is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 3 of the License, or (at your
option) any later version.

The GNU MP Library is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
License for more details.

You should have received a copy of the GNU Lesser General Public License
along with the GNU MP Library.  If not, see http://www.gnu.org/licenses/.  */

#define GMP_LIMB_BITS 32
#define BYTES_PER_MP_LIMB 4

/* Generated by tuneup.c */

#define MOD_1_NORM_THRESHOLD                 3
#define MOD_1_UNNORM_THRESHOLD               9
#define MOD_1N_TO_MOD_1_1_THRESHOLD         13
#define MOD_1U_TO_MOD_1_1_THRESHOLD          6
#define MOD_1_1_TO_MOD_1_2_THRESHOLD        16
#define MOD_1_2_TO_MOD_1_4_THRESHOLD         0  /* never mpn_mod_1s_2p */
#define PREINV_MOD_1_TO_MOD_1_THRESHOLD     31
#define USE_PREINV_DIVREM_1                  1
#define DIVEXACT_1_THRESHOLD                 0  /* always (native) */
#define BMOD_1_TO_MOD_1_THRESHOLD          102

#define MUL_TOOM22_THRESHOLD                16
#define MUL_TOOM33_THRESHOLD                66
#define MUL_TOOM44_THRESHOLD               171
#define MUL_TOOM6H_THRESHOLD               258
#define MUL_TOOM8H_THRESHOLD               357

#define MUL_TOOM32_TO_TOOM43_THRESHOLD     113
#define MUL_TOOM32_TO_TOOM53_THRESHOLD     129
#define MUL_TOOM42_TO_TOOM53_THRESHOLD     115
#define MUL_TOOM42_TO_TOOM63_THRESHOLD     129

#define SQR_BASECASE_THRESHOLD               0  /* always (native) */
#define SQR_TOOM2_THRESHOLD                 16
#define SQR_TOOM3_THRESHOLD                113
#define SQR_TOOM4_THRESHOLD                193
#define SQR_TOOM6_THRESHOLD                254
#define SQR_TOOM8_THRESHOLD                381

#define MULMOD_BNM1_THRESHOLD               13
#define SQRMOD_BNM1_THRESHOLD               11

#define MUL_FFT_MODF_THRESHOLD             332  /* k = 5 */
#define MUL_FFT_TABLE3                                      \
  { {    332, 5}, {     17, 6}, {      9, 5}, {     19, 6}, \
    {     11, 5}, {     23, 6}, {     17, 7}, {      9, 6}, \
    {     19, 7}, {     11, 6}, {     25, 7}, {     15, 6}, \
    {     31, 7}, {     19, 8}, {     11, 7}, {     27, 8}, \
    {     15, 7}, {     33, 8}, {     19, 7}, {     39, 8}, \
    {     23, 7}, {     47, 8}, {     27, 9}, {     15, 8}, \
    {     35, 7}, {     71, 8}, {     39, 9}, {     23, 8}, \
    {     51,10}, {     15, 9}, {     31, 8}, {     67, 9}, \
    {     39, 8}, {     79, 9}, {     55,10}, {     31, 9}, \
    {     79,10}, {     47, 9}, {     95,11}, {     31,10}, \
    {     63, 9}, {    127, 8}, {    255, 9}, {    135,10}, \
    {     79, 9}, {    159,10}, {     95, 9}, {    191, 8}, \
    {    383,11}, {     63,10}, {    127, 9}, {    255, 8}, \
    {    511, 9}, {    271,10}, {    143, 9}, {    287, 8}, \
    {    607,10}, {    159, 9}, {    319,11}, {     95,10}, \
    {    191, 9}, {    383,12}, {     63,11}, {    127,10}, \
    {    255, 9}, {    511,10}, {    271, 9}, {    543, 8}, \
    {   1087,10}, {    287, 9}, {    607,11}, {    159,10}, \
    {    351, 9}, {    703, 8}, {   1407,11}, {    191,10}, \
    {    415, 9}, {    831,11}, {    223,10}, {    479, 9}, \
    {    959,12}, {    127,11}, {    255,10}, {    543, 9}, \
    {   1087,11}, {    287,10}, {    607, 9}, {   1215,11}, \
    {    351,10}, {    703, 9}, {   1407,12}, {    191,11}, \
    {    383,10}, {    767,11}, {    415,10}, {    831,11}, \
    {    479,10}, {    959,13}, {    127,12}, {    255,11}, \
    {    543,10}, {   1087,11}, {    607,10}, {   1215,12}, \
    {    319,11}, {    703,10}, {   1407,11}, {    735,10}, \
    {   1471,12}, {    383,11}, {    831,12}, {    447,11}, \
    {    959,10}, {   1919,13}, {    255,12}, {    511,11}, \
    {   1087,12}, {    575,11}, {   1215,10}, {   2431,12}, \
    {    703,11}, {   1471,13}, {    383,12}, {    959,11}, \
    {   1919,14}, {    255,13}, {    511,12}, {   1215,11}, \
    {   2431,13}, {    639,12}, {   1471,11}, {   2943,10}, \
    {   5887,13}, {    767,12}, {   1599,13}, {    895,12}, \
    {   1919,11}, {   3839,14}, {    511,13}, {   1023,12}, \
    {   2111,13}, {   1151,12}, {   2431,13}, {   1407,12}, \
    {   2943,11}, {   5887,14}, {    767,13}, {   1919,12}, \
    {   3839,15}, {    511,14}, {   1023,13}, {   2431,14}, \
    {   1279,13}, {   2943,12}, {   5887,14}, {   1535,13}, \
    {   3199,14}, {   1791,13}, {   3839,12}, {   7679,15}, \
    {   1023,14}, {  16384,15}, {  32768,16} }
#define MUL_FFT_TABLE3_SIZE 163
#define MUL_FFT_THRESHOLD                 3456

#define SQR_FFT_MODF_THRESHOLD             308  /* k = 5 */
#define SQR_FFT_TABLE3                                      \
  { {    308, 5}, {     13, 6}, {      7, 5}, {     17, 6}, \
    {      9, 5}, {     19, 6}, {     13, 7}, {      7, 6}, \
    {     17, 7}, {      9, 6}, {     19, 7}, {     11, 6}, \
    {     24, 7}, {     15, 6}, {     31, 7}, {     21, 8}, \
    {     11, 7}, {     25, 8}, {     15, 7}, {     31, 8}, \
    {     19, 7}, {     39, 8}, {     23, 7}, {     47, 8}, \
    {     27, 9}, {     15, 8}, {     31, 4}, {    607, 5}, \
    {    319, 7}, {     95, 8}, {     55, 9}, {     31, 8}, \
    {     63, 9}, {     39, 8}, {     79, 9}, {     47,10}, \
    {     31, 9}, {     79,10}, {     47,11}, {     31,10}, \
    {     63, 9}, {    127, 8}, {    255, 7}, {    511,10}, \
    {     79, 9}, {    159, 8}, {    319,10}, {     95, 9}, \
    {    191, 8}, {    383,11}, {     63,10}, {    127, 9}, \
    {    255, 8}, {    543, 7}, {   1087, 9}, {    287, 8}, \
    {    607,10}, {    159, 9}, {    319,11}, {     95,10}, \
    {    191, 9}, {    383,12}, {     63,11}, {    127,10}, \
    {    255, 9}, {    543, 8}, {   1087,10}, {    287, 9}, \
    {    607,11}, {    159,10}, {    351, 9}, {    703, 8}, \
    {   1407, 9}, {    735,11}, {    191,10}, {    415, 9}, \
    {    831,11}, {    223,10}, {    479, 9}, {    959, 8}, \
    {   1919,12}, {    127,11}, {    255,10}, {    543, 9}, \
    {   1087,11}, {    287,10}, {    607, 9}, {   1215,11}, \
    {    351,10}, {    703, 9}, {   1407,12}, {    191,11}, \
    {    415,10}, {    831,11}, {    479,10}, {    959, 9}, \
    {   1919,13}, {    127,12}, {    255,11}, {    543,10}, \
    {   1087,11}, {    607,10}, {   1215,12}, {    319,11}, \
    {    703,10}, {   1407,11}, {    735,12}, {    383,11}, \
    {    831,12}, {    447,11}, {    959,10}, {   1919, 9}, \
    {   3839,13}, {    255,12}, {    511,11}, {   1087,12}, \
    {    575,11}, {   1215,10}, {   2431,12}, {    703,11}, \
    {   1407,13}, {    383,12}, {    959,11}, {   1919,10}, \
    {   3839,14}, {    255,13}, {    511,12}, {   1215,11}, \
    {   2431,13}, {    639,12}, {   1471,11}, {   2943,13}, \
    {    767,12}, {   1599,13}, {    895,12}, {   1919,11}, \
    {   3839,14}, {    511,13}, {   1151,12}, {   2431,13}, \
    {   1407,12}, {   2943,14}, {    767,13}, {   1919,12}, \
    {   3839,15}, {    511,14}, {   1023,13}, {   2431,14}, \
    {   1279,13}, {   2943,14}, {   1791,13}, {   3839,15}, \
    {   1023,14}, {  16384,15}, {  32768,16} }
#define SQR_FFT_TABLE3_SIZE 155
#define SQR_FFT_THRESHOLD                 2368

#define MULLO_BASECASE_THRESHOLD             0  /* always */
#define MULLO_DC_THRESHOLD                  56
#define MULLO_MUL_N_THRESHOLD             5240

#define DC_DIV_QR_THRESHOLD                 59
#define DC_DIVAPPR_Q_THRESHOLD             216
#define DC_BDIV_QR_THRESHOLD                56
#define DC_BDIV_Q_THRESHOLD                136

#define INV_MULMOD_BNM1_THRESHOLD           30
#define INV_NEWTON_THRESHOLD               260
#define INV_APPR_THRESHOLD                 244

#define BINV_NEWTON_THRESHOLD              266
#define REDC_1_TO_REDC_N_THRESHOLD          62

#define MU_DIV_QR_THRESHOLD               1308
#define MU_DIVAPPR_Q_THRESHOLD            1334
#define MUPI_DIV_QR_THRESHOLD              130
#define MU_BDIV_QR_THRESHOLD              1017
#define MU_BDIV_Q_THRESHOLD               1308

#define MATRIX22_STRASSEN_THRESHOLD         15
#define HGCD_THRESHOLD                     111
#define GCD_DC_THRESHOLD                   606
#define GCDEXT_DC_THRESHOLD                273
#define JACOBI_BASE_METHOD                   3

#define GET_STR_DC_THRESHOLD                14
#define GET_STR_PRECOMPUTE_THRESHOLD        26
#define SET_STR_DC_THRESHOLD               270
#define SET_STR_PRECOMPUTE_THRESHOLD       860
